/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hyleak;

import java.io.File;
import java.io.PrintWriter;
import support.Edge;
import support.EdgeList;
import support.Logger;
import support.Node;
import support.NodeList;

/**
 *
 * @author  
 */
class ControlFlowGraph {

    private static final Logger logger = Logger.getInstance();

    private NodeList nodes = new NodeList();
    private EdgeList edges = new EdgeList();

    ControlFlowGraph(NodeList nodes, EdgeList edges) {
        this.nodes = nodes;
        this.edges = edges;
    }

    public NodeList getNodes() {
        return nodes;
    }

    public void setNodes(NodeList nodes) {
        this.nodes = nodes;
    }

    public EdgeList getEdges() {
        return edges;
    }

    public void setEdges(EdgeList edges) {
        this.edges = edges;
    }

    public void printToPNGFile(String filename) {
        String type = "-Tpng";
        try {
            File dotFile = new File(filename + ".dot");
            try (PrintWriter out = new PrintWriter(dotFile)) {
                out.println("digraph G {");
                out.println("\trankdir = \"TB\";");
                for (Node n : nodes) {
                    if (n.getCodeline().startsWith("then")){
                        
                    }else if (n.getCodeline().startsWith("else")){
                    
                    //} else if (n.getCodeline().startsWith("goto")){
                    
                    }else{
                        n.printToGraph(out);
                    }
                }
                for (Edge e : edges) {

                    out.println("\t\"" + e.getFrom() + "\" -> \"" + e.getTo() + "\" [label = \"" + e.getLabel() + "\"];");

                }

                out.println("}");
            }

            File imgFile = new File(filename + "." + type.substring(2));

            String[] args = {HyLeak.DOT, type, dotFile.getAbsolutePath(), "-o", imgFile.getAbsolutePath()};
            log("Running: " + args[0] + " " + args[1] + " " + args[2] + " " + args[3] + " " + args[4], 1);
            Process p = Runtime.getRuntime().exec(args);
            p.waitFor();
            //dotFile.delete();

        } catch (java.io.IOException ioe) {
            System.err.println("Error: in I/O processing files or in calling external command.");
        } catch (java.lang.InterruptedException ie) {
            System.err.println("Error: the execution of the external program was interrupted.");
        }
    }

    private static void log(Object aObject, int level) {
        if (logger.getVerbosity() >= level) {
            Logger loggy = Logger.getInstance();
            loggy.log(String.valueOf(aObject), level);
        }
    }

    @Override
    public String toString() {
        String toreturn = "Nodes:\n";
        for (Node n : nodes) {
            toreturn += n.getElement() + ": " + n.getCodeline() + "\n";
        }
        toreturn += "Edges:\n";
        for (Edge e : edges) {
            toreturn += e.toString() + "\n";
        }
        return toreturn;
    }

}
