/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hyleak;

import java.math.BigInteger;

import distributions.MapDistribution;

/**
 *
 * @author  
 */
class MarkovStateDistributionVariable extends Variable{
    protected MapDistribution distribution;

    public MarkovStateDistributionVariable(String name, boolean isPrivate, int length, Interval interval) {
        super(name, isPrivate, length);
        distribution = new MapDistribution(interval);
    }
    
    public MarkovStateDistributionVariable(MarkovStateDistributionVariable var) {
        super(var.getName(), var.isPrivate(), var.getLength());
        distribution = new MapDistribution(var.getDistribution());
    }
    
    public MarkovStateDistributionVariable(String name, boolean isPrivate, int length, String description) {
        super(name, isPrivate, length);
        distribution = new MapDistribution(description);
    } 
   
    public MarkovStateDistributionVariable(String name, boolean isPrivate, int length, BigInteger value) {
        super(name, isPrivate, length);
        distribution = new MapDistribution(value);
    }

    public MapDistribution getDistribution() {
        return distribution;
    }

    public void setDistribution(MapDistribution distribution) {
        this.distribution = distribution;
    }
    
    public boolean isDirac(){
        return this.distribution.isDirac();
    }
    
    public BigInteger getMaximum(){
        return this.distribution.getMaximum();
    }
    
     public BigInteger getMinimum(){
        return this.distribution.getMinimum();
    }
    
    public BigInteger getSize(){
        return distribution.getSize();
    }

    
    @Override
    public String toString(){
        String toreturn;
        if (distribution.isDirac()){
            toreturn = this.getName()+"="+this.distribution.getMinimum().toString();
        }else{
            toreturn = this.getName()+"="+this.distribution.toString();
        }
        return toreturn;
    }

//    CompressedDistribution getCompressedDistribution() {
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
//    }
    
    @Override
    public MarkovStateDistributionVariable clone() throws CloneNotSupportedException{
        System.out.println("cloning MarkovStateDistributionVariable");
        MarkovStateDistributionVariable toreturn = (MarkovStateDistributionVariable) super.clone();
        toreturn.setDistribution(distribution);
        return toreturn;
        
    }
}
