/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hyleak;

import distributions.SingleDistribution;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Iterator;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author  
 */
public class MasterMatrixReader  implements Iterable{
    
    private final File file;
    private SingleDistribution initialPrior;
    
    public MasterMatrixReader(String filename){
        file = new File(filename);
        log("Created master matrix reader for file "+filename,2);
        Scanner scanner = null;
        try {
            scanner = new Scanner(new FileReader(file));
            
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MatrixReaderIterator.class.getName()).log(Level.SEVERE, null, ex);
        }
        String initialSubFilename = scanner.nextLine().trim();
        log("Prior file name is "+initialSubFilename,2);
        initialPrior = support.ConvertLeakiEstObjects.computeSingleDistributionFromPriorFile(initialSubFilename);
        
    }

    public File getFile() {
        return file;
    }

    @Override
    public Iterator<MatrixSignature> iterator() {
        return new MatrixReaderIterator(this);
    }

    public SingleDistribution getInitialPrior() {
        return initialPrior;
    }
    
    private static void log(Object aObject, int level){
        support.Logger.getInstance().log(String.valueOf(aObject),level);
    }
}
