/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hyleak;

import java.math.BigDecimal;

import distributions.MapDistribution;
import support.Contexter;
import support.Logger;

/**
 *
 * @author  
 */
class ProbabilisticGuard {
    protected static final Contexter contexter = Contexter.getInstance();
    protected static final Logger logger = Logger.getInstance();
    
    protected final MarkovStateDistributionVariable variable;
    protected final VariableList vars;
    protected final MapDistribution argument;
    protected final String operator;
    protected final MapDistribution expvalue;
    
    protected VariableList truevars;
    protected VariableList falsevars;
    protected BigDecimal proboftrue;
    
    ProbabilisticGuard(MarkovStateDistributionVariable variable, VariableList thenvars, MapDistribution argdist, String operator, MapDistribution expval) {
        log("Building probabilistic guard",4);
        this.variable = variable;
        this.vars = thenvars;
        this.argument = argdist;
        this.operator = operator;
        this.expvalue = expval;
        
        this.truevars = null;
        this.falsevars = null;
        this.proboftrue = new BigDecimal(-1.0);
    }

    VariableList getVarsIfTrue() {
        if (proboftrue.compareTo(contexter.getDecimalZero())<0){
            this.solve();
        }
        return truevars;
    }

    VariableList getVarsIfFalse() {
        if (proboftrue.compareTo(contexter.getDecimalZero())<0){
            this.solve();
        }
        return falsevars;
    }

    BigDecimal getProbOfTrue() {
        if (proboftrue.compareTo(contexter.getDecimalZero())<0){
            this.solve();
        }
        return proboftrue;
    }
    
    private static void log(Object aObject, int level){
        Logger loggy = Logger.getInstance();
        loggy.log(String.valueOf(aObject),level);
    }

    private void solve() {
        
        log("Evaluating guard "+argument.toString()+' '+operator+' '+expvalue.toString(),4);
        if (argument.isDirac()){
            if (expvalue.isDirac()){
                // both distributions are dirac, so the guard is true with probability either 0 or 1
                log("The guard is Dirac",4);
                DiracGuard dirguard = new DiracGuard(variable, vars, argument, operator, expvalue);
                this.proboftrue = dirguard.getProbOfTrue();
                this.truevars = dirguard.getVarsIfTrue();
                this.falsevars = dirguard.getVarsIfFalse();
            }else{
                // only argument is Dirac
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }
        }else{
            if (expvalue.isDirac()){
                // only expression is Dirac
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }else{
                // both argument and expression are non-Dirac
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }
        }
    }
}
