/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hyleak;

import distributions.SingleDistribution;

import java.math.BigDecimal;
import java.util.HashMap;

import support.Contexter;
import support.Logger;

/**
 *
 * @author  
 * @author  
 */
public abstract class SimulationSignature extends Signature{
    private static final Logger logger = Logger.getInstance();
    
    protected final MarkovChainState initialState;
    protected final VariableList obsVar;
    protected final VariableList privVar;
    protected final boolean isAbstract;
    //private int id;

    SimulationSignature(MarkovChainState currstate, VariableList obsvar, VariableList privvar, boolean abstr) {
        initialState = currstate;
        obsVar = obsvar;
        privVar = privvar;
        isAbstract = abstr;
        Logger.getInstance().log("Created simulation signature for "+initialState.printNice(), 4);
        //id = IdGenerator.getInstance().getId();
    }

//    public int getId() {
//        return id;
//    }
    

    public MarkovChainState getInitialState() {
        return initialState;
    }

    public VariableList getObsVars() {
        return obsVar;
    }

    public VariableList getPrivVars() {
        return privVar;
    }
    
    public VariableList getSecVars(){
        VariableList secVars = new VariableList();
        for (Variable aVar : privVar){
            PrivateVariable priVar =(PrivateVariable)aVar;
            if (priVar.isSecret()){
                secVars.add(priVar);
            }
        }
        return secVars;
    }

    public boolean isAbstract() {
        return isAbstract;
    }

 
    public BigDecimal getProbability() {
        BigDecimal probOfState = initialState.getProbability();
        return probOfState;
    }
    
    public SingleDistribution getSubPrior(){
        IntervalAssignments assign = new IntervalAssignments(privVar);
        String[] labels = assign.getAllValues();
        Contexter cont = Contexter.getInstance();
        BigDecimal probOfState = initialState.getProbability();
	    //log("INFO(SimSig54): probOfState = "+probOfState,3);
        BigDecimal singleProb = cont.getDecimalOne().multiply(probOfState).divide(new BigDecimal(labels.length,cont.getContext()),cont.getContext());  // TODO: to be checked
        HashMap<String,BigDecimal> probMap = new HashMap<>();
        for(String label : labels) {
            probMap.put(label, singleProb);
        }
        //SingleDistribution subPrior = new SingleDistribution(labels,probMap);
        //subPrior.print("subPriorFromSimSig",3);
        
        return new SingleDistribution(labels,probMap);
    }

    public int getSizeOfSupport() {
        IntervalAssignments assign = new IntervalAssignments(privVar);
        String[] labels = assign.getAllValues();
        return labels.length;
    }

    // TODO: to be implemented later
    public int getSizeOfEstimatedSizesOfSecrets() {
    	return 0;
    }

    // TODO: to be implemented for obtaining initial sample sizes
    public int getSizeOfEstimatedSizesOfObservables() {
    	return 0;
    }

    private static void log(Object aObject, int level){
        if (logger.getVerbosity() >= level) {
            Logger loggy = Logger.getInstance();
            loggy.log(String.valueOf(aObject),level);
        }
    }
}
