/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.util.HashSet;


/** Free a public non observable variable that is not used in the rest of the program. */
public class FreeStatement extends Statement {
    private final String variable;
        
    public FreeStatement(String v) {
       	usedVariables = new HashSet<>();
        this.variable = v;
        nbStatements = 1;
    }
    
    @Override
    public Statement replace(String oldv, String newv) {
        return new FreeStatement(variable);
    }
    
    @Override
    public String toString(int line) {
    	return "free " + variable + ";\n";
    }
}
