/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.io.PrintWriter;
import java.util.HashMap;
import java.math.BigDecimal;

/**  Launch all 4 preprocessors sucessively
 *
 */
public class Preprocessor {
    public static void preprocess(String filename, HashMap<String,BigDecimal> constants, boolean free) throws Exception {
	Preprocessor1.preprocess(filename, constants);
	boolean simulate = Preprocessor2.preprocess(filename + ".1.pp");
	if (!simulate) {
	    Preprocessor3.preprocess(filename + ".2.pp");
	    Preprocessor4.preprocess(filename + ".3.pp");
	} else {
	    Preprocessor4.preprocess(filename + ".2.pp");
	}
    }
    
    public static void main(String[] args) throws Exception {
        preprocess(args[0],null,true);
    }
}
