/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.io.PrintWriter;
import org.antlr.runtime.*;
import support.Logger;

/** Unroll for loops
 *  Expand array declarations.
 *  Return true if there already exists simulate statement in the code. 
 */
public class Preprocessor2 {
    public static boolean preprocess(String filename) throws Exception {
	Logger.getInstance().log("==== Preprocessor 2 ====",3);
    	Programme prog = new Programme(null);
        Preprocessor2Lexer lexer = new Preprocessor2Lexer(new ANTLRFileStream(filename));
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        Preprocessor2Parser parser = new Preprocessor2Parser(tokens);
        String statements = parser.prog_grammar(prog);
        try(  PrintWriter out = new PrintWriter(filename.replace(".1",".2")) ) {
	    prog.print(out);
   	    out.println(statements);
	}
	return parser.simulate;
    }
    
    public static void main(String[] args) throws Exception {
        preprocess(args[0]);
    }
}
