/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.io.PrintWriter;
import org.antlr.runtime.*;
import support.Logger;

/** Final preprocessor to transform the code into if-goto code.
 *
 */
public class Preprocessor4 {
    public static void preprocess(String filename) throws Exception {
	Logger.getInstance().log("==== Preprocessor 4 ====",3);
    
	Programme prog = new Programme(null);
        Preprocessor4Lexer lexer = new Preprocessor4Lexer(new ANTLRFileStream(filename));
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        Preprocessor4Parser parser = new Preprocessor4Parser(tokens);
        parser.prog_grammar(prog);
	try( PrintWriter out = new PrintWriter(filename.replaceAll("\\.\\d\\.",".4.")) ) {
	    prog.print(out);
	}
    }
    
    public static void main(String[] args) throws Exception {
        preprocess(args[0]);
    }
}
