/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.util.HashSet;;

public class ReturnStatementSimulate extends ReturnStatement {
    
    private String obsVariable;
    private String filename;
    private String privVariable;
    
    public ReturnStatementSimulate() {
        usedVariables = new HashSet<Variable>();
      	nbStatements = 1;
    }
    
    public ReturnStatementSimulate(String obsVariable, String filename, String privVariable) {
      	usedVariables = new HashSet<Variable>();
      	nbStatements = 1;
        this.obsVariable = obsVariable;
        this.filename = filename;
        this.privVariable = privVariable;
    }

    public void setObsVariable(String obsVariable) {
        this.obsVariable = obsVariable;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public void setPrivVariable(String privVariable) {
        this.privVariable = privVariable;
    }
    
    public Statement replace(String oldv, String newv) {
        String newObsVar = obsVariable.replace("("+oldv+")","("+newv+")");
        newObsVar = newObsVar.replace("("+oldv+"[","("+newv+"[");
        String newPrivVar = privVariable.replace("("+oldv+")","("+newv+")");
        newPrivVar = newPrivVar.replace("("+oldv+"[","("+newv+"[");
        return new ReturnStatementSimulate(newObsVar,filename,newPrivVar);
    }
    
    public String toString(int line) {
        return "return after simulate " + obsVariable + ":=" + filename + "(" + privVariable + ");\n";
    }
}
