/*  HyLeak is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2014-2017 - 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: 
*/

package preprocessor;

import java.util.Collection;
import java.util.HashSet;

public abstract class Statement {

    protected HashSet<Variable> usedVariables;
    
    protected int nbStatements;
    
    protected int getNbStatements() {
    	return nbStatements;
    }
    
    public void addUsedVariable(Variable var) {
    	usedVariables.add(var);
    }
    
    public void addUsedVariable(Collection<Variable> vars) {
    	for (Variable var : vars) {
    		usedVariables.add(var);
    	}
    }
    
    public HashSet<Variable> getUsedVariables() {
    	return usedVariables;
    }
    
    public abstract Statement replace(String oldv, String newv);
    
    public abstract String toString(int line);
}
