package test;

import bham.leakwatch.LeakWatchAPI;
import java.security.SecureRandom;

public class LyingCryptographers {

    public static void main(String[] args) {
        SecureRandom rnd = new SecureRandom();

        int cryptNum = 8;
        int cryptPerTable = cryptNum/2;
        // convert secret text to byte array
        int payer = rnd.nextInt(cryptNum+1);
        LeakWatchAPI.secret("h", payer);
        
        int liar = 1+rnd.nextInt(cryptNum);
        boolean outA=false, outB=false, outC=false;
        boolean[] coinsA = new boolean[cryptPerTable];
        boolean[] coinsB = new boolean[cryptPerTable];
        boolean[] coinsC = new boolean[cryptPerTable];
        
        //toss coins 
        for (int i=0; i<cryptPerTable; i++){
            coinsA[i]=rnd.nextBoolean();
            coinsB[i]=rnd.nextBoolean();
            coinsC[i]=rnd.nextBoolean();
        }
        
        //decide declarations
        boolean[] declA = new boolean[cryptPerTable];
        boolean[] declB = new boolean[cryptPerTable];
        boolean[] declC = new boolean[cryptPerTable];
        for (int i=0; i<cryptPerTable; i++){
            declA[i]=coinsA[i]^coinsA[(i+1)%cryptPerTable];
            if (payer==i+1) {
                declA[i]=!declA[i];
            }
            if (liar==i+1){
                declA[i]=!declA[i];
            }
            outA = outA ^ declA[i];
            
            declB[i]=coinsB[i]^coinsB[(i+1)%cryptPerTable];
            if (payer==i+3) {
                declB[i]=!declB[i];
            }
            if (liar==i+3){
                declB[i]=!declB[i];
            }
            outB = outB ^ declB[i];
            
            declC[i]=coinsC[i]^coinsC[(i+1)%cryptPerTable];
            if (payer==i+5) {
                declC[i]=!declC[i];
            }
            if (liar==i+1){
                declC[i]=!declC[i];
            }
            outC = outC ^ declC[i];
        }
        LeakWatchAPI.observe(outA);
        LeakWatchAPI.observe(outB);
        LeakWatchAPI.observe(outC);

    }
}
