/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.math.RoundingMode;
import java.util.LinkedHashMap;
import java.util.Map;

import distributions.*;
import hyleak.*;
import support.*;
import theory.*;

/**
 *
 * @author  
 * @author  
 */
public class testJointDistManager {

    public static String dir = "examples/leakiEstFiles/";
    public static String priorFileName;
    public static String channelFileName;
    private static final Contexter contexter = Contexter.getInstance();
    private static final Logger logger = Logger.getInstance();

    public static void main(String args[]) {
        System.out.println("test for SingleDistribution:");
        testExactDist();
    }

    // Test the case of only trace analysis
    private static void testExactDist() {
        // read a prior and a chennel from files
        priorFileName = dir + "prior4uni.txt";
        channelFileName = dir + "dc3allbias4.txt";
        SingleDistribution priorDistribution = ConvertLeakiEstObjects.computeSingleDistributionFromPriorFile(priorFileName);
        JointDistribution jointDist = ConvertLeakiEstObjects.computeJointDistFromDistributionFiles(priorFileName, channelFileName);

        // precision
        int precision = 10;
        MathContext context = new MathContext(precision,RoundingMode.HALF_EVEN);
        Contexter contexter = Contexter.getInstance();
        contexter.setContext(context);
        log("Setting precision to "+precision,4);

        //SingleDistribution[] listSubPriors;  // TODO: please implement to compute this from the hyleak code.
        // create a priorDM
        System.out.println("create a priorDM");
        DistributionPriorDistributionManager pdm = new DistributionPriorDistributionManager("h",priorDistribution);
        // initialize the JPD manager
        System.out.println("initialize the JPD manager");
        JointPosteriorDistributionManager jpdm = new JointPosteriorDistributionManager(pdm, BigInteger.valueOf(10000));
        // store the joint distribution to the JPD manager
        System.out.println("store the joint distribution to the JPD manager");
        jpdm.storeExactSubDistToManager(jointDist);
        // compute the total joint distribution
        System.out.println("compute the total joint distribution");
        jpdm.computeTotalJointDistribution();
        // print input/output distributions
        jpdm.getDistributionOnSecrets().print();
        jpdm.getDistributionOnObservables().print();
        // posterior entropy, corrected MI, confidence interval
        BigDecimal postEntropy = jpdm.computePosteriorShannonEntropy();
        BigDecimal correctedMI = jpdm.computeCorrectedMIPointEstimate();
        BigDecimal[] confidenceInterval = jpdm.computeConfidenceIntervalOfMI();
        // print the results
        System.out.println("posterior entropy   = " + postEntropy);
        System.out.println("corrected MI        = " + correctedMI);
        System.out.println("confidence interval = [" + confidenceInterval[0] + ", " + confidenceInterval[1] + "]");
    }

    /////////////////////////////////////////////////////////////
    // log
    private static void log(Object aObject, int level){
        if (logger.getVerbosity() >= level) {
            Logger loggy = Logger.getInstance();
            loggy.log(String.valueOf(aObject),level);
        }
    }
}
