#cd "/Users/user14/svn/2014/leakbytrace/trunk/figs/sample-size"
#set title "Corrected MI values and sample size "  font 'Arial,28'
unset title
#set terminal svg font "Arial,13" rounded dashed
#set output "resultMI-rand-sample-size.svg"
set terminal postscript font "Arial,27" rounded dashed
set term postscript color enhanced eps
set output "random-walk_time_graph.eps"

# Margins
set lmargin 8
set rmargin 2
set tmargin 1
set bmargin 3

# Line style for axes
set style line 80 lt 1      # lt: 1=solid, 3=dashed
set style line 80 lt rgb "#000000" lw 2
#
# # Line style for grid
set style line 81 lt 1      # lt: 1=solid, 3=dashed
set style line 81 lt rgb "#C3C3C3"
# # Line style for plot
set style line 1 lt rgb "#A00000" lw 6 pt 7     # MI/MEL plots -- for colour: #A00000
set style line 3 lt rgb "#0000E0" lw 6          # MEL lower/upper bound plots -- for colour: #00A000

set grid xtics mxtics ytics mytics back linestyle 81
set border 3 back linestyle 80 # Remove border on top and right.  These
                               # borders are useless and make it harder
							   # to see plotted lines near the border.
							   # Also, put it in grey; no need for so much emphasis on a border.

set xlabel "Walking steps" offset 0,0.5,0 font ",20"
#set xrange[0.000:0.001]
set xtics 1 font ",22" nomirror out
set mxtics 1
set ylabel "Time in ms" offset 3.5,0,0 font ",20"
#set yrange[0:20]
set ytics font ",19" nomirror out
set mytics 2

set key right font ',22'
#unset key

# explanatory labels on graph
#set label 1 left at graph 0.05,0.42 " Corrected \n mutual information"  font 'Arial,24'
#set label 2 left at graph 0.01,0.52 " Lower \n bounds"  font 'Arial,24'
#set label 3 left at graph 0.19,0.30 " Corrected \n mutual information"  font 'Arial,24'
#set label 4 left at graph 0.69,0.30 " Upper \n bounds"  font 'Arial,24'
#set arrow 1 from 0.2106,100 to  0.2242,100 nohead lw 5 lt 1 lc rgb "red"   #upper for size10000
#set arrow 2 from 0.2106, 95 to  0.2106,105 nohead lw 8 lt 1 lc rgb "red"   #upper for size10000
#set arrow 3 from 0.2242, 95 to  0.2242,105 nohead lw 8 lt 1 lc rgb "red"   #upper for size10000
#set arrow 4 from 0.2076, 75 to  0.2269, 75 nohead lw 6 lt 1 lc rgb "blue"  #upper for size5000
#set arrow 5 from 0.2076, 70 to  0.2076, 80 nohead lw 8 lt 1 lc rgb "blue"  #upper for size5000
#set arrow 6 from 0.2269, 70 to  0.2269, 80 nohead lw 8 lt 1 lc rgb "blue"  #upper for size5000
#set arrow 7 from 0.1950, 55 to  0.2398, 55 nohead lw 6 lt 1 lc rgb "black" #upper for size1000
#set arrow 8 from 0.1950, 50 to  0.1950, 60 nohead lw 8 lt 1 lc rgb "black" #upper for size1000
#set arrow 9 from 0.2398, 50 to  0.2398, 60 nohead lw 8 lt 1 lc rgb "black" #upper for size1000

plot \
"random-walk_time_prec.txt" title "Precise"  with lines lw 12 lt 1 lc rgb "dark-red", \
"random-walk_time_fullsim.txt"  title "Full simulation" with lines lw 14 lt 6 lc rgb "blue", \
"random-walk_time_abs-sim.txt"  title "HyLeak" with lines lw 20 lt"-" lc rgb "#008000", \
