#!/bin/bash
RESULT_FILE=random-walk_result.txt
TEMP_FILE=random-walk_temp.txt

TIME_PREC_FILE=random-walk_time_prec.txt
TIME_SIM_FILE=random-walk_time_fullsim.txt
TIME_ABS_FILE=random-walk_time_abs-sim.txt 

rm -f random-walk_time_*.txt

ERR_PREC_FILE=random-walk_err_prec.txt
ERR_SIM_FILE=random-walk_err_fullsim.txt
ERR_ABS_FILE=random-walk_err_abs-sim.txt 

rm -f random-walk_err_*.txt

SIMS=50000
echo "Random walk example test results" > $RESULT_FILE
for MAX in 2 3 4 5 6 7
do
  echo ==========MAX=$MAX========== >> $RESULT_FILE
  PARAMS="-v 0 --verb:CORRECTEDLEAKAGE:=1 --verb:TIME:=1 --const:MAX:=$MAX --no-cfg"
  echo "Precise:" >> $RESULT_FILE
  ../hyleak -i 0 ../examples/random-walk_abs-sim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $MAX  >> $TIME_PREC_FILE
  echo -n " " >> $TIME_PREC_FILE
  echo $TIME >> $TIME_PREC_FILE
  
  REAL_RESULT=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $MAX  >> $ERR_PREC_FILE
  echo  " 0" >> $ERR_PREC_FILE
done
 
for MAX in 2 3 4 5 6 7
do
  echo ==========MAX=$MAX========== >> $RESULT_FILE
  PARAMS="-v 0 --verb:CORRECTEDLEAKAGE:=1 --verb:TIME:=1 --const:MAX:=$MAX --no-cfg"
  echo "Full simulation:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/random-walk_fullsim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $MAX  >> $TIME_SIM_FILE
  echo -n " " >> $TIME_SIM_FILE
  echo $TIME >> $TIME_SIM_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $MAX  >> $ERR_SIM_FILE
  echo -n " " >> $ERR_SIM_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_SIM_FILE

  echo "HyLeak:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/random-walk_abs-sim.hyleak $PARAMS >$TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $MAX  >> $TIME_ABS_FILE
  echo -n " " >> $TIME_ABS_FILE
  echo $TIME >> $TIME_ABS_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $MAX  >> $ERR_ABS_FILE
  echo -n " " >> $ERR_ABS_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_ABS_FILE
  
done

rm $TEMP_FILE
gnuplot random-walk_time_imgsrc.plt
gnuplot random-walk_err_imgsrc.plt
