#!/bin/bash
RESULT_FILE=smartgrid_result.txt
TEMP_FILE=smartgrid_temp.txt

TIME_PREC_FILE=smartgrid_time_prec.txt
TIME_SIM_FILE=smartgrid_time_fullsim.txt
TIME_ABS_FILE=smartgrid_time_abs-sim.txt 

rm -f smartgrid_time_*.txt

ERR_PREC_FILE=smartgrid_err_prec.txt
ERR_SIM_FILE=smartgrid_err_fullsim.txt
ERR_ABS_FILE=smartgrid_err_abs-sim.txt 

rm -f smartgrid_err_*.txt

SIMS=50000
echo "Smartgrid example test results" > $RESULT_FILE
for S in 1 2 3 4 5 
do
  echo ==========S=$S========== >> $RESULT_FILE
  PARAMS="-v 0 --verb:CORRECTEDLEAKAGE:=1 --verb:TIME:=1 --const:S:=$S --no-cfg"
  echo "Precise:" >> $RESULT_FILE
  ../hyleak -i 0 ../examples/smartgrid_fullsim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $S  >> $TIME_PREC_FILE
  echo -n " " >> $TIME_PREC_FILE
  echo $TIME >> $TIME_PREC_FILE
  
  REAL_RESULT=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $S  >> $ERR_PREC_FILE
  echo  " 0" >> $ERR_PREC_FILE
  
  echo "Full simulation:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/smartgrid_fullsim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $S  >> $TIME_SIM_FILE
  echo -n " " >> $TIME_SIM_FILE
  echo $TIME >> $TIME_SIM_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $S  >> $ERR_SIM_FILE
  echo -n " " >> $ERR_SIM_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_SIM_FILE

  echo "HyLeak:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/smartgrid_abs-sim.hyleak $PARAMS >$TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $S  >> $TIME_ABS_FILE
  echo -n " " >> $TIME_ABS_FILE
  echo $TIME >> $TIME_ABS_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $S  >> $ERR_ABS_FILE
  echo -n " " >> $ERR_ABS_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_ABS_FILE
  
done

rm $TEMP_FILE
gnuplot smartgrid_time_imgsrc.plt
gnuplot smartgrid_err_imgsrc.plt
