#!/bin/bash
RESULT_FILE=window_result.txt
TEMP_FILE=window_temp.txt

TIME_PREC_FILE=window_time_prec.txt
TIME_SIM_FILE=window_time_fullsim.txt
TIME_ABS_FILE=window_time_abs-sim.txt 

rm -f window_time_*.txt

ERR_PREC_FILE=window_err_prec.txt
ERR_SIM_FILE=window_err_fullsim.txt
ERR_ABS_FILE=window_err_abs-sim.txt 

rm -f window_err_*.txt

SIMS=25000
echo "Window example test results" > $RESULT_FILE
for W in 10 12 14 16 
do
  N=$((W*2))
  echo ==========N=$N,W=$W========== >> $RESULT_FILE
  PARAMS="-v 0 --verb:CORRECTEDLEAKAGE:=1 --verb:TIME:=1 --const:N:=$N --const:W:=$W --no-cfg"
  echo "Precise:" >> $RESULT_FILE
  ../hyleak -i 0 ../examples/window_abs-sim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $N  >> $TIME_PREC_FILE
  echo -n " " >> $TIME_PREC_FILE
  echo $TIME >> $TIME_PREC_FILE
  
  REAL_RESULT=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $N  >> $ERR_PREC_FILE
  echo  " 0" >> $ERR_PREC_FILE
  
  echo "Full simulation:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/window_fullsim.hyleak $PARAMS > $TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $N  >> $TIME_SIM_FILE
  echo -n " " >> $TIME_SIM_FILE
  echo $TIME >> $TIME_SIM_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $N  >> $ERR_SIM_FILE
  echo -n " " >> $ERR_SIM_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_SIM_FILE

  echo "HyLeak:" >> $RESULT_FILE
  ../hyleak -i $SIMS ../examples/window_abs-sim.hyleak $PARAMS >$TEMP_FILE
  cat $TEMP_FILE >> $RESULT_FILE
  TIME=$(cat $TEMP_FILE | sed -n '2p'|cut -d':' -f2)
  echo -n $N  >> $TIME_ABS_FILE
  echo -n " " >> $TIME_ABS_FILE
  echo $TIME >> $TIME_ABS_FILE

  ERR=$(cat $TEMP_FILE | sed -n '1p')
  echo -n $N  >> $ERR_ABS_FILE
  echo -n " " >> $ERR_ABS_FILE
  echo `bc <<< "$ERR-$REAL_RESULT"` >> $ERR_ABS_FILE
  
done

rm $TEMP_FILE
gnuplot window_time_imgsrc.plt
gnuplot window_err_imgsrc.plt
